<?php
/**
 * @Copyright 2006-2008 JoomSuite
 * @created 16.02.2009
 */
defined('_JEXEC') or die('Restricted Access');
class plgJoomsuite_contentCommunity extends JPlugin
{
	function plgJoomsuite_contentCommunity( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'helper.php');
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models');
		JTable::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'tables');
	}
	
	function onBeforeFieldRender(&$field, &$user)
	{

	}

	function onAfterArticleRender(&$article, $params)
	{
		//return "on after article render event";
	}
	function onBeforeArticleRender(&$article, $params)
	{
		if(JRequest::getVar('option') != 'com_resource') return;
		if (!$group = $this->isCommunityGroup()){return;}
		global $mainframe, $Itemid;
		$group_id = JRequest::getInt('client_id', 0);
		if(!$this->checkAccess('read'))
		{
			JError::raiseNotice(404, JText::_("You do not have access to the contents of this group"));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group_id.'&Itemid='.$Itemid, false));
			return;
		}

		return $this->generateMenu($group);
	}

	function onCommentSubmit(&$comment, $record, $params)
	{
		if(JRequest::getVar('option') != 'com_resource') return;
		if(!$this->isCommunityGroup()){return;}
		
		$group_id = JRequest::getInt('client_id', 0);
		
		if(!$this->checkAccess('comment'))
		{
			JError::raiseNotice(404, JText::_("You do not have access to submit comments to this group"));
			$comment = false;
			return;
		}
	}
	
	function onArticleSubmit(&$record, $params)
	{
		if(JRequest::getVar('option') != 'com_resource') return;
		if (!$this->isCommunityGroup()){return;}
		global $mainframe, $Itemid;
		$group_id = JRequest::getInt('client_id', 0);
		if(!$this->checkAccess('submit'))
		{
			JError::raiseNotice(404, JText::_("You do not have access to submit records to this group"));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group_id.'&Itemid='.$Itemid, false));
			return;
		}
	}

	function onCommentsFormRender(&$record, &$comments, &$params)
	{
		if(JRequest::getVar('option') != 'com_resource') return;
		if (!$this->isCommunityGroup()){return;}
		$group_id = JRequest::getInt('client_id', 0);
		if(!$this->checkAccess('comment'))
		{
			$message = JText::_("You cannot post comments here");
			$params->set('comments_access', 3);
			return $message;
		}
	}

	function onBeforeListRender(&$params, $items = array())
	{
		global $mainframe, $Itemid;
		
		if (JRequest::getVar('option') != 'com_resource') 
			return;
		
		if ($group = $this->isCommunityGroup())
		{
			if(is_object($params)) $params->set('show_page_title', 0);
			
			$group_id = JRequest::getInt('client_id', 0);
			
			if(!$this->checkAccess('read'))
			{
				//JError::raiseNotice(404, JText::_("You do not have access to the contents of this group"));
				$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group_id.'&Itemid='.$Itemid, false));
				return;
			}
			
			return $this->generateMenu($group);
		}
	}

	function generateMenu($currentGroup = null)
	{

		jimport('joomla.filesystem.file');
		//require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'helper.php');
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models');
		JTable::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'tables');
		
		$category_id 		= JRequest::getInt('category_id');
		$listModel 			= &JModel::getInstance('List', 'ResModel');
		$resourceCategory 	= $listModel->getCategory($category_id);
        $group_id 			= JRequest::getInt('client_id', 0);
		if(!$currentGroup){
    		$groupModel 		= &JModel::getInstance('Group', "CommunityModel");
    		$groupModel->setId($group_id);
    		$currentGroup 		= &$groupModel->getData();
		}

		$user = &JFactory::getUser();
		
		
/******Here we will check the access of the user*****/
		/*		if (!CommunityHelperGroups::checkGroupAcess($user, $group_id, $currentGroup->access, $currentGroup->user_id))
		 {
			JError::raiseNotice(404, JText::_('You not have access to view this section'));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$currentGroup->id.'&Itemid='.$Itemid));
			}

			*/
	
		$groupParams = new JParameter($currentGroup->get('params'));
	
  		$sections = $groupParams->get("used_sections");
		settype($sections, 'array');
		foreach($sections AS $section)
		{
			$realValue[$section]['additional'] = $listModel->getCategory($section);
			$realValue[$section]['total'] = CommunityHelperResource::getNumRecords($section, $currentGroup->title, $currentGroup->id);
		}

		$groupsModel = &JModel::getInstance('Groups', 'CommunityModel');
		$groupsModel->setCategory($currentGroup->catid);
		$currentCategory = $groupsModel->getCurrentCategory();
		
		$Itemid = $this->params->get('group_itemid');
		
		ob_start();
		require(JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content'.DS.'community'.DS.($this->params->get('template') ? $this->params->get('template') : 'default').'.php');
		$menu = ob_get_contents();
		ob_end_clean();

		return $menu;
	}

	function checkAccess($type)
	{
		static $params = null;
		
		$group_id = JRequest::getInt('client_id', 0);
		$category_id = JRequest::getInt('category_id');

		$groupModel = &JModel::getInstance('Group', "CommunityModel");
		$groupModel->setId($group_id);
		$currentGroup = &$groupModel->getData();

		$user = &JFactory::getUser();
		
		switch($type)
		{
			case 'submit':
				return CommunityHelperGroups::checkGroupAccess($user, $group_id, $currentGroup->submit_access, $currentGroup->user_id);
				break;
			case 'read':
				return CommunityHelperGroups::checkGroupAccess($user, $group_id, $currentGroup->access, $currentGroup->user_id);
				break;
			case 'comment':
				return CommunityHelperGroups::checkGroupAccess($user, $group_id, $currentGroup->comments_access, $currentGroup->user_id, false);
				break;
		}
		if (empty($params))
		{
			jimport('joomla.filesystem.file');
			$ini = JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini');
			$params = new JParameter($ini);
		}
		if ($params->get('carma::enable'))
		{
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php');
			switch($type)
			{
				case 'submit':
					if (!CommunityHelperGroups::checkGroupCarmaAccess($user, $group_id, $currentGroup->user_id, 'submit_access_karma_limit'))
					{
						JError::raiseNotice(500, JText::_('You do not have enough carma to submit to this group'));
						return false;
					}
					break;
				case 'read':
					if (!CommunityHelperGroups::checkGroupCarmaAccess($user, $group_id, $currentGroup->user_id, 'access_karma_limit'))
					{
						JError::raiseNotice(500, JText::_('You do not have enough carma to access the contents of this group'));
						return false;
					}
					break;
				case 'comment':
					if (!CommunityHelperGroups::checkGroupCarmaAccess($user, $group_id, $currentGroup->user_id, 'comment_access_karma_limit'))
					{
						JError::raiseNotice(500, JText::_('You do not have enough carma to comment into this group'));
						return false;
					}
					break;
			}

		}

		return true;
	}
	
	function isCommunityGroup()
	{
		$client     = JRequest::getVar('client', '');
		$group_id   = JRequest::getInt('client_id', 0);
		if ($client == '' || $group_id == 0)
		{
			return false;
		}
		$groupModel = &JModel::getInstance('Group', "CommunityModel");
		$groupModel->setId($group_id);
		$currentGroup = &$groupModel->getData();
		if ($currentGroup->title == urldecode(stripslashes($client)) || $currentGroup == $client)
		{
			return $currentGroup;
		}

		return false;
	}
	
	/**
	 * Get PeopleTouch groups.
	 */
	function &getGroups() {
		static $groups = 0;
		if (empty($groups)) 
		{
			$db = & JFactory::getDBO();
			$db->setQuery('SELECT a.* FROM #__community_communities AS a');
		
			$groups = $db->loadObjectList();
		}
		
		return $groups;
	}
}
