<?php
/**
 * @Copyright 2006-2008 JoomSuite
 * @created 09.12.2008
 */
defined('_JEXEC') or die('Restricted Access');

class plgCommunityCommunity extends JPlugin
{
	function plgCommunityCommunity(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}


	function onSqlJoin()
	{

	}

	function onSqlWhere()
	{
		global $mainframe, $Itemid;

		$db = &JFactory::getDBO();
		$where = "";

		$search_default = $mainframe->getUserStateFromRequest('com_community.filter_search'.$Itemid, 'search_word', JText::_("--Text Search--"), 'string');

		if ( $search_default && $search_default != JText::_("--Text Search--"))
		{
			$where .= "\n( u.name LIKE '%".$db->getEscaped($search_default)."%' ";
			$where .= "\n OR u.username LIKE '%".$db->getEscaped($search_default)."%' ";
			$where .= "\n OR u.usertype LIKE '%".$db->getEscaped($search_default)."%' )";
		}
		return $where;
	}


	function onCustomUserList($client, $limitstart, $limit)
	{
		if($client!='community'){return;}
		global $mainframe;
		$view_what = JRequest::getVar('view-what', 'members');
		$group_id = JRequest::getInt('group', 0);
		if ($group_id == 0)
		{
			return;
		}
		$limit = intval($limit);
		$limitstart = intval($limitstart);
		JRequest::setVar('customlist_tmpl', $this->params->get('template', COMMUNITY_GENERAL_DEFAULT_CUSTOMLIST_TEMPLATE));
		if ($view_what == 'invite')
		{
			return $this->getUsersForInvite($group_id, $limitstart, $limit);
		}
		$db = &JFactory::getDBO();


		$db->setQuery("SELECT u.*, cc.ctime AS join_date, 'creator' AS access_type, 0 AS user_block FROM #__users AS u LEFT JOIN #__community_communities AS cc ON cc.user_id = u.id WHERE  cc.id = {$group_id}");
		$creator = $db->loadObject();

		$members = $this->getGroupMembers($group_id, $view_what, false, false, $limit, $limitstart);
		array_unshift($members, $creator);
		jimport ('joomla.utilities.date');
		for($i = 0; $i<count($members); $i++)
		{
			$member = &$members[$i];
			$member->custom_data = "";

			$custom_data = JText::_("Member Type").": ";
			if ($member->access_type == 1)
			{
				$custom_data .= JText::_("Moderator");
			}
			else if ($member->access_type == 'creator')
			{
				$custom_data .= JText::_("Creator");
			}
			else
			{
				$custom_data .= JText::_("Member");
			}
			if($this->params->get('show_joined', 1))
			{
				$custom_data .= "<br />";
				$date = new JDate($member->join_date);
				$custom_data .= '<span class="createdate">'.JText::_("Joined");
				$custom_data .= ": ";
				$custom_data .= $date->toFormat(COMMUNITY_GENERAL_DATE_FORMAT).'</span>';
			}
			$member->custom_data = $custom_data;

		}

		$total = $this->getGroupMembers($group_id, $view_what, false, true);
		$groupModel = &JModel::getInstance("Group", 'CommunityModel');
		$groupModel->setId($group_id);
		$groupsModel = &JModel::getInstance('Groups', 'CommunityModel');

		$group = &$groupModel->getData();
		$groupsModel->setCategory($group->catid);
		$currentCategory = $groupsModel->getCurrentCategory();
		$groups_url = JRoute::_("index.php?option=com_community&view=groups&layout=default&category_id={$currentCategory->id}&Itemid=".COMMUNITY_GENERAL_GROUPS_ITEMID);
		$group_url = JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$group->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);
		$pathway = &$mainframe->getPathway();
		$pathway->addItem($currentCategory->title, $groups_url);
		$pathway->addItem($group->title, $group_url);
		$pathway->addItem(JText::_('Member List'), "");
		$return = new StdClass();
		$return->users = $members;
		$return->total = $total;
		$return->page_title = JText::sprintf("Members of %s Group", $group->title);
		$return->description = '<a href="'.$group_url.'">'.JText::_('Back to group').'</a><br /><br />';//.$group->get('description');

		$return->notice = 0;
		return $return;

	}
	function getGroupMembers($group_id, $type = "all", $include_blocked = true, $count = false, $limit = null, $limitstart=null)
	{
		$blocked = "";
		$limitStr = "";
		$db = &JFactory::getDBO();
		if ($limit > 0)
		{
			$limitStr = " LIMIT ".($limitstart>0?$limitstart.",":"")." {$limit}";

		}
		if (!$include_blocked)
		{
			$blocked = " AND um.user_block = 0 ";
		}
		$groupBy = " GROUP BY (u.id) ";
		$sql = '';
		$selectStmt = " u.*,  um.ctime as join_date, um.access_type, um.user_block ";
		if ($count)
		{
			$selectStmt = " DISTINCT COUNT(*) ";
			$groupBy="";
		}

		switch($type)
		{

			case 'moderators':
				$sql = "SELECT  $selectStmt  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id} AND um.access_type = 1 AND pending = 0 ".$blocked.$groupBy.$limitStr;
				break;
			case 'members':
				$sql = "SELECT $selectStmt  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id} AND um.access_type = 0 AND pending = 0  ".$blocked.$groupBy.$limitStr;
				break;
			default:
			case 'all':
				$sql = "SELECT $selectStmt FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id} AND pending = 0  ".$blocked.$groupBy.$limitStr;
				break;

		}

		$db->setQuery($sql);
		if ($count)
		{
			return $db->loadResult();
		}
		return $db->loadObjectList();
	}


	function getUsersForInvite($group_id, $limitstart, $limit)
	{

		$return = new StdClass();
		$return->users = array();

		$return->description = "";
		$return->notice = 0;
		$return->total = 0;

		$user = &JFactory::getUser();
		if ($user->get('id') < 1) { return;	}

		$db = &JFactory::getDBO();
		$tGroup = &JTable::getInstance('Groups', "CommunityTable");
		$tGroup->load($group_id);
		$return->page_title = JText::_("Invite your friends to")." ".$tGroup->get("title");

		$limitStr = CommunityHelperGeneral::getLimitString($limitstart, $limit);

		$sql = "SELECT user_id FROM #__community_user_mapping WHERE group_id = {$group_id} AND user_block = 0 AND pending = 0";
		$db->setQuery($sql);
		$users = $db->loadResultArray();
		
		$users[] = $tGroup->user_id;
		$users =  'u.id NOT IN ('.implode(",", $users).')';

		$sql = "SELECT count(*) FROM #__users AS u
			LEFT JOIN #__community_userrelations AS ur ON ur.friend_id = u.id OR ur.user_id = u.id
			WHERE ".$users."  AND ur.user_id = {$user->id} OR ur.friend_id = {$user->id}  GROUP BY u.id";
		$db->setQuery($sql);
		$return->total = $db->loadResult();

		$sql = "SELECT u.* FROM #__users AS u
		LEFT JOIN #__community_userrelations AS ur ON ur.friend_id = u.id OR ur.user_id = u.id
		WHERE (ur.user_id = {$user->id} OR ur.friend_id = {$user->id}) AND {$users} GROUP BY u.id {$limitStr}";
		$db->setQuery($sql);

		$return->users = $db->loadObjectList();
		if(count($return->users)){
		    $return->description = "<div style='text-align:left;'>
			<input type='button' value='".JText::_("Send Invintations")."' onclick='sumitbutton(\"invite_friends\");' class='button' />
    			&nbsp<input type='button' value='".JText::_("Cancel")."' onclick='history.go(-1);' class='button' />
    		<input type='hidden' name='controller' value='customlist' />
    		<input type='hidden' name='group_id' value='{$group_id}' />
    		</div><p></p>";
    		$return->description.= "<script language='javascript'>\n
    			function sumitbutton(task)\n
    			{\n
    				var form = document.adminForm;\n
    				var selected = false;
    				form.getElements('input[id^=userid]').each(function(e){
                        if(e.checked){
                        	selected = true;
                        }
                    });
    				
					if(selected){
    					form.task.value= task;\n
    					form.submit();\n
					}else{
						alert('".JText::_('Select user(s)!')."');
					}
    			}\n
    			</script>";
		}else{
		    $return->description = "<div style='text-align:left;'>
				<input type='button' value='".JText::_("Cancel")."' onclick='history.go(-1);' class='button' />
			</div>";
		
		}
		for($i = 0; $i < count($return->users); $i++ )
		{
			$user = &$return->users[$i];
			$user->custom_data = '<center><input type="checkbox" name="inv_user[]" id="userid'.$user->id.'" value="'.$user->id.'" /></center>';
		}

		return $return;
	}
}

?>