<?php
/**
 * @fileID: $Id: juser.php 7350 2011-09-22 14:00:12Z kostya $
 * @changedDate: $LastChangedDate: 2011-09-22 21:00:12 +0700 (Чт, 22 сен 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyTouch Integration plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

class plgCommunityJUser extends JPlugin
{
	function plgCommunityJuser(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$loaded = $this->loadLanguage();

	}

	function onRenderFilters()
	{
		global $mainframe;
		$user = &JFactory::getUser();
		$selected = JRequest::getVar('juserfilter', array(), 'post');
		if(!count($selected))
		$selected = $mainframe->getUserState('juserfilter');
		$db = &JFactory::getDBO();
		$gid = $user->get('aid', 0);
		
		$selected_fields = $this->params->get('list_field');
	    if( $selected_fields ){
	        if(!is_array($selected_fields))
		        settype($selected_fields, 'array');
		    $selected_fields = " AND id IN(".implode(",", $selected_fields).")";
		}else{
		   return;
		}

		$sql = "SELECT * FROM #__juser_extended_fields WHERE `type` IN('radio', 'checkbox', 'select', 'mult_select') AND `published` = 1 AND params LIKE '%searcheable=1%'  AND access <=".(int)$gid.$selected_fields;
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		$out = array();

		if ($this->params->get('use_zip'))
		{
			$search_zip_point = JRequest::getVar('search_zip_point', '');
			$search_self_zip_code = JRequest::getVar('search_self_zip_code', '');
			$search_self_zip_distance = JRequest::getVar('search_zip_distance', '');
			$diatance_points = array();
			$diatance_points[] = JHTML::_('select.option',  'm', JText::_( 'Miles' ) );
			$diatance_points[] = JHTML::_('select.option',  'k', JText::_( 'Kilometers' ) );
			$diatance_points[] = JHTML::_('select.option',  'n', JText::_( 'Nautical miles' ) );

			$out['juser_zip'] = JText::_('Your Zip').': <input type="text" name="search_self_zip_code" size="5" value="'.$search_self_zip_code.'">';
			$out['juser_zip_within'] = JText::_( 'find within' ).': <input type="text" name="search_zip_distance" size="5" value="'.$search_self_zip_distance.'">'.JHTML::_('select.genericlist',   $diatance_points, 'search_zip_point', 'class="inputbox" size="1" ', 'value', 'text', $search_zip_point );
		}
		foreach ($result as $field)
		{
			$field_params = new JParameter($field->params);
			$values = explode("\n",$field_params->get('values'));
			$options = array();
			$options[] = JHTML::_('select.option', '', JText::_("--{$field->title}--"));
			foreach ($values as $val)
			{
				$options[] = JHTML::_('select.option', $val, $val);
			}

			$out['juser_'.$field->id] = JHTML::_("select.genericlist", $options, "juserfilter[{$field->id}]", "class='inputbox' onchange='document.adminForm.submit();'", 'value', 'text', (isset($selected[$field->id] )&& $selected[$field->id]) ? $selected[$field->id] : "");
		}
		if (count($out))
		{
			return $out;
		}
	}

	function onSqlWhere()
	{
		global $mainframe, $Itemid;

		$filters = JRequest::getVar('juserfilter', array());
		if(!count($filters))$filters = $mainframe->getUserState('juserfilter');

		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();
		$out = array();

		if ($this->params->get('use_zip'))
		{
			$search_zip_point = JRequest::getVar('search_zip_point', '');
			$search_self_zip_code = JRequest::getVar('search_self_zip_code', '');
			$search_self_zip_distance = JRequest::getVar('search_zip_distance', '');


			if( $search_self_zip_distance && $search_self_zip_code && $this->params->get('use_zip')){

				$sql = "SELECT zip.*"
				."\n    FROM #__juser_zip_code AS zip, #__juser_extended_data as f_val"
				."\n    WHERE f_val.user_id = ".$user->get('id', 0)." AND f_val.field_id = ".$this->params->get('zip_field')." AND zip.zip_code = f_val.fvalue";
				;

				$db->setQuery($sql);
				$zip_param = $db->loadObjectList( $sql );

				$zip_param = @$zip_param[0];
				$multiplier = array('m' => 1, 'k' => 1.609344, 'n' => 0.8684);
				$out[] = '(DEGREES(acos(sin(RADIANS(zip.lat)) * sin(RADIANS('.(int)@$zip_param->lat.')) +  cos(RADIANS(zip.lat)) * cos(RADIANS('.(int)@$zip_param->lat.')) * cos(RADIANS(zip.lon - ('.(int)@$zip_param->lon.'))))) * 60 * 1.1515) <= '.$search_self_zip_distance * @$multiplier[$search_zip_point];
			}
		}
		if(count($filters))
		{
			foreach ($filters as $key => $val)
			{
				if (!empty($val) && $key !='general')
				{
					$out[] = "juserfields{$key}.fvalue LIKE '%$val%'";
				}
			}
		}

		$search_default = $mainframe->getUserStateFromRequest('com_community.filter_search'.$Itemid, 'search_word', JText::_("--Text Search--"), 'string');
		if ( $search_default && $search_default != JText::_("--Text Search--"))
		{
			$sql = "SELECT * FROM #__juser_extended_fields WHERE `type` IN('text', 'textarea') AND `published` = 1 AND params LIKE '%searcheable=1%'  AND access <=".$user->get('aid', 0);
			$db->setQuery($sql);
			$textFields = $db->loadObjectList();

			foreach($textFields as $field)
			{
				$out[] = "juserfields{$field->id}.fvalue LIKE '%{$search_default}%'";
			}
		}
		
		if(count($out))
		{
			$out = '('.implode(' AND ', $out).')';
			return $out;
		}
	}

	function onSqlJoin()
	{
		global $mainframe, $Itemid;

		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();

		$filters = JRequest::getVar('juserfilter', array());
		if(!count($filters))$filters = $mainframe->getUserState('juserfilter');

		//$sql = "SELECT * FROM #__juser_extended_fields WHERE `type` IN('radio', 'checkbox', 'select') AND `published` = 1 AND `params` LIKE '%searcheable=1%'";
		//$db->setQuery($sql);
		//$result = $db->loadObjectList();

		$out = "";

		if ($this->params->get('use_zip') && (int)$this->params->get('zip_field') > 0)
		{
			$zip_field = (int)$this->params->get('zip_field');
			$search_zip_distance  = (string)@$filters['search_zip_distance'];
			$search_self_zip_code = (string)@$filters['search_self_zip_code'];
			$search_zip_point     = (string)@$filters['search_zip_point'];
			$out .= "\n LEFT JOIN #__juser_extended_data AS juserfieldszip{$zip_field} ON u.id = juserfieldszip{$zip_field}.user_id AND juserfieldszip{$zip_field}.field_id = $zip_field ";
			$out .= "\n LEFT JOIN #__juser_zip_code AS zip ON juserfieldszip{$zip_field}.fvalue = zip.zip_code";


		}

		$search_default = $mainframe->getUserStateFromRequest('com_community.filter_search'.$Itemid, 'search_word', JText::_("--Text Search--"), 'string');
		if ( $search_default && $search_default != JText::_("--Text Search--"))
		{
			$sql = "SELECT * FROM #__juser_extended_fields WHERE `type` IN('text', 'textarea') AND `published` = 1 AND params LIKE '%searcheable=1%'  AND access <=".$user->get('aid', 0);
			$db->setQuery($sql);
			$textFields = $db->loadObjectList();

			foreach($textFields as $field)
			{
				$out.= "\n LEFT JOIN #__juser_extended_data AS juserfields{$field->id} ON u.id = juserfields{$field->id}.user_id AND juserfields{$field->id}.field_id = $field->id ";
			}
		}


		$filters = JRequest::getVar('juserfilter', array());
		if(!count($filters))$filters = $mainframe->getUserState('juserfilter');
		if(count($filters))
		{
			foreach ($filters as $key => $val)
			{
				if (!empty($val) && $key !='general')
				{
					$out.= "\n LEFT JOIN #__juser_extended_data AS juserfields{$key} ON u.id = juserfields{$key}.user_id AND juserfields{$key}.field_id = '$key' ";
				}
			}
			$mainframe->setUserState('juserfilter', $filters);
		}

		//foreach ($result as $val)
		//{
		//	$out.= "\n LEFT JOIN #__juser_extended_data AS juserfields{$val->id} ON u.id = juserfields{$val->id}.user_id AND juserfields{$val->id}.field_id = $val->id ";
		//}

		return $out;
	}

	/**
	 * The function that returns the avatar to be shown on the page
	 *
	 * @param object $user - JUser Object
	 */
	function onRenderAvatar(&$user)
	{

		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'))
		{
			$config = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'.DS.'config.ini';
			if (JFile::exists($config))
			{
				$params = new JParameter(JFile::read($config));
				$dir = $params->get('general::avatars_dir', 'administrator/components/com_juser/avatars/');
				$dir = ereg_replace('^/', '', $dir);
				$dir = ereg_replace('/$', '', $dir);
				$dir2 = str_replace("/", DS, $dir);
				if(JFile::exists(JPATH_ROOT.DS.$dir2.DS.$user->username.".jpg"))
				{
					$user->avatar = $dir."/{$user->username}.jpg";
					return;
				}
				else if(JFile::exists(JPATH_ROOT.DS.$dir2.DS.$user->username.".jpeg"))
				{
					$user->avatar = $dir."/{$user->username}.jpeg";
					return;
				}
				else if(JFile::exists(JPATH_ROOT.DS.$dir2.DS.$user->username.".png"))
				{
					$user->avatar = $dir."/{$user->username}.png";
					return;
				}
				else if(JFile::exists(JPATH_ROOT.DS.$dir2.DS.$user->username.".gif"))
				{
					$user->avatar = $dir."/{$user->username}.gif";
					return;
				}
			}
		}

		$user->avatar = "components/com_juser/images/default_avatar.png";
	}


	function onProfileExtra($user, $params='', $name)
	{
		if ($name!='juser'){return;}
		if ($this->params->get('profile_fields', 0) < 1 )
		{
			return;
		}
		$field_list =  $this->params->get('profile_fields');
		if (!is_array($field_list))
		{
			$field_list = array($field_list);

		}
		require_once(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'includes'.DS.'helper.php');
		$currentUser = &JFactory::getUser();
		$aid = $currentUser->get('aid');
		$db = &JFactory::getDBO();

		$sql =  " SELECT f.id as id1, f.fvalue AS text, f.fvalue AS fvalue, ff.id as id2, ff.title as title, ff.type, ff.params as params, ff.alias as alias, c.id as id3, c.title as category "
		." FROM #__juser_extended_data AS f "
		." INNER JOIN #__juser_extended_fields AS ff ON ff.id = f.field_id "
		." INNER JOIN #__categories AS c ON ff.catid = c.id "
		." WHERE f.user_id = {$user->id} AND ff.access <= $aid AND ff.id IN (".implode(" , ", $field_list).")"
		." ORDER BY c.ordering, ff.ordering ";
		$db->setQuery($sql);
		$data = $db->loadObjectList();
		$ret = array();
		$out = "";
		$counter = 0;
		$counter2= 0;
		$current_catid = null;
		$category_separator_header = "\n".'<h3>%s</h3><div class="contentpaneopen">';
		$category_separator_footer = "\n".'</div><span class="article_separator">&nbsp;</span>';
		//$out.= "<table width='100%'>";
		$flag = false;
		foreach($data as $field_num => $field){
			$field->text = $this->renderFieldForOutput($user, $field);
			if ($field->text == '')
			{

				continue;

			}

			$counter++;


			if(($current_catid != $field->id3 && $counter>0) ){
				if ($this->params->get('show_categories', 1) && $counter2 > 0 ){$out .= '</table>'; $out .= $category_separator_footer;}

				if ($this->params->get('show_categories', 1))
				{
					$counter2++;
					$out .= sprintf($category_separator_header, $field->category);
					$current_catid = $field->id3;
				}
				$out .= '<table width="100%" cellspacing="1" >';

			}
			$out .= '<tr>';
			//$result .= JUFrame::renderField($field, $JS_validation);
			//JSTODO: add if statement on textarea allowraw parameter
			$text = JSUserFrontHelper::renderFieldForPrint($user->id, $field);
			$out.="\n<td width='150' valign='top'>{$field->title}:</td><td>{$text}</td>";
			$out .= '</tr>';


		}
		$out .= '</table>';
		if ($this->params->get('show_categories', 1)) {$out .= $category_separator_footer;}
		if ($counter >0)
		{
			$tab = new JSCommunityTab(); // To make the life easier there is a class with properties for the tabs
			$tab->text = $out;
			$tab->title = JText::_('User Personal Data');
			$tab->name = "jsu_additional_details";
			$ret = $tab;
			return $ret;
		}
	}


	/**
	 * Triggers on displaying user list
	 *
	 * @param JUser Object $user
	 * @return stdClass Object
	 * $out->lable - The lable of the field
	 * $out->value - Value of the field
	 * !!!IMPORTANT!!!
	 * return value cannot be array
	 */

	function onListExtra($user)
	{
		if ($this->params->get('where_to_show') == 0 || $this->params->get('where_to_show') ==2 )
		return $this->getSimpleExtra($user, $this->params->get('list_field'));
	}

	function onProfileCoreData($user)
	{
		if ($this->params->get('where_to_show') == 1 || $this->params->get('where_to_show') == 2)
		{
			return $this->getSimpleExtra($user, $this->params->get('list_field'));
		}

	}
	function getSimpleExtra($user, $fields)
	{
		if(!$fields) return;
		if(!is_array($fields)) settype($fields, 'array');
		$currentUser = &JFactory::getUser();
		$aid = $currentUser->get('aid');
		if (is_array($fields) && count($fields)>0 )
		{
			$db = &JFactory::getDBO();
			$out = new stdClass();
			$sql = "SELECT f.id AS id1, f.type, f.title AS lable, d.id as id2, d.fvalue, f.params FROM #__juser_extended_fields AS f"
			."\n LEFT JOIN #__juser_extended_data AS d ON f.id = d.field_id"
			."\n LEFT JOIN #__categories AS c ON f.catid = c.id"
			."\n WHERE d.user_id = {$user->id} AND d.field_id IN (".implode(" , ", $fields).')  AND f.access <= '.$aid.' ORDER BY c.ordering, f.ordering';
			$db->setQuery($sql);
			$data = $db->loadObjectList();
			$out = array();

			if (count($data) > 0)
			{
				foreach ($data as $item)
				{

					if ($item->fvalue != '')
					{
						$f =  new StdClass();
						$f->lable = $item->lable;
						$f->value = $this->renderFieldForOutput($user, $item);
						$out[] = $f;
					}
				}
			}
			return $out;
		}
	}

	function onProfileMenu($profile)
	{
		$user = JFactory::getUser();
		if ($user->get('id')>0 && $user->id == $profile->id && $this->params->get('show_menu_link'))
		{
			$itemId = $this->params->get('item_itemid', JRequest::getInt('Itemid'));
			$menu = new stdClass();
			$menu->link = "index.php?option=com_juser&controller=user&view=user&layout=mydetails&Itemid={$itemId}";
			$menu->icon="plugins/community/icons/changedetails.png";
			$menu->alt = $this->params->get('menu_item_title',JText::_("Edit Details"));
			$menuItems[] = $menu;
			$ret = new stdClass();
			if ($this->params->get('show_menu_title'))
			{
				$ret->title = $this->params->get('menu_title', JText::_("User Menu"));
			}
			$ret->menuItems = $menuItems;
			return $ret;
		}

	}

	function renderFieldForOutput($user, $field)
	{
		require_once(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'api.php');
		return JSUserFrontHelper::renderFieldForPrint($user->id, $field);
	}

}
?>