<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityMember extends JPlugin
{
	function plgCommunityMember(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;
		$this->loadLanguage();
	}

	function onProfileExtra( $user,  $params = null, $name )
	{
		if ($name != 'member'){return;}

		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;

		$me = JFactory::getUser();
		if ($user->id != $me->get('id'))
		{
			return;
		}
		ob_start();
		$language = &JFactory::getLanguage();
		$language->load('com_jcs');
		$itemid = JRequest::getInt('Itemid');
		$view   = JRequest::getVar('view');
		$layout = JRequest::getVar('layout');
		$option = JRequest::getVar('option');
		$client = JRequest::getVar('client');

		JRequest::setVar( 'layout', 'history');
		JRequest::setVar( 'view',   'jcs');
		JRequest::setVar( 'option', 'com_jcs');
		JRequest::setVar( 'client',  'community');

		jimport( 'joomla.application.component.model' );

		JModel::addIncludePath( JPATH_BASE.DS.'components'.DS.'com_jcs'.DS.'models' );
		JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'.DS.'tables' );


		require_once( JPATH_BASE.DS.'components'.DS.'com_jcs'.DS.'views'.DS.'jcs'.DS.'view.html.php' );

		require_once( JPATH_BASE.DS.'components'.DS.'com_jcs'.DS.'controller.php' );
		require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'.DS.'controllers'.DS.'cnf.php' );
		require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'.DS.'library'.DS.'helper.php' );

		JcsControllerCnf::initialyze();

		$controller = new JcsController( );

		$view = &$controller->getView('jcs');

		$view->_setPath( 'template', JPATH_BASE.DS.'components'.DS.'com_jcs'.DS.'views'.DS.'jcs'.DS.'tmpl' );

		$controller->execute( JRequest::getVar( 'task' ) );

		JRequest::setVar( 'Itemid',     $itemid );
		JRequest::setVar( 'controller', JRequest::getVar( 'controller' ) );
		JRequest::setVar( 'view',       'jcs' );
		JRequest::setVar( 'layout',     $layout );
		JRequest::setVar( 'option',     $option );
		JRequest::setVar( 'client',     $client );

		$result = ob_get_contents();
		ob_end_clean();

		$ret = new JSCommunityTab();
		$ret->name  = 'jspt_memeber';
		$ret->title = JText::_('Subscriptions History');
		$ret->text  = $result;

		return $ret;
	}

	function onRenderFilters()
	{
		global $mainframe;
		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;

		$f = $this->params->get('subscribtions');
		$fields = array();
		if (!is_array($f))
		{
			$fields[] = $f;
		}
		else
		{
			$fields = $f;
		}
		$fields = $this->_cleanArray($fields);
		if (count($fields) < 1)
		{
			return;
		}
		$options = array();
		$db = &JFactory::getDBO();
		$selected = JRequest::getVar('memberfilter', '', "POST");
		if($selected == '') $selected = $mainframe->getUserState('memberfilter');


		$sql = "SELECT `name` AS `text`, `id` AS `value` FROM #__jcs_plans WHERE id IN (".implode(" , ", $fields).")";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		$options = array();
		$options[] =  JHTML::_('select.option', "none", "--By Subscribtions--");
		//$options[] = JHTML::_('select.option', "any", "Any Subscribtion" );
		foreach ($result as $opt)
		{
			$options[] = $opt;

		}
		return array("member"=> JHTML::_('select.genericlist',  $options, 'memberfilter', 'class="inputbox" onchange="document.adminForm.submit();" ', 'value', 'text', $selected));
	}

	function onSqlJoin()
	{
		global $mainframe;
		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;

		$filters = JRequest::getVar('memberfilter', '');
		if($filters == '') $filters = $mainframe->getUserState('memberfilter');
		if ($filters == '' || $filters == 'none')
		{
			$mainframe->setUserState('memberfilter', $filters);
			return;
		}

		$out  = "\n LEFT JOIN #__jcs_user_subscr AS mebersubscribtions ON u.id = mebersubscribtions.user_id ";
		$out .= "\n LEFT JOIN #__jcs_plans AS memberplans ON mebersubscribtions.subscription_id = memberplans.id ";

		$mainframe->setUserState('memberfilter', $filters);

		return $out;
	}

	function onSqlWhere()
	{
		global $mainframe;
		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;

		$out = '';
		$filters = JRequest::getVar('memberfilter', '');
		if($filters == '') $filters = $mainframe->getUserState('memberfilter');

		if ($filters == '' || $filters == 'none')
		{
			return;
		}
		else if ($filters == 'any')
		{
			$f = $this->params->get('subscribtions');
			$fields = array();
			if (!is_array($f))
			{
				$fields[] = $f;
			}
			else
			{
				$fields = $f;
			}
			$fields = $this->_cleanArray($fields);
			$out = " memberplans.id IN ( ".implode(" , ", $fields)." ) ";
		}
		else
		{
			$out = " memberplans.id = ".$filters;

		}
		return $out;
	}
	function onCustomUserList($client, $limitstart, $limit)
	{

		if ($client != 'member'){return;}

		$jcs_file = JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'jcs.php';
		if(!file_exists($jcs_file)) return;

		$db = &JFactory::getDBO();
		$f = $this->params->get('subscr_for_custom', array());

		$fields = array();
		if (!is_array($f))
		{
			$fields[] = $f;
		}
		else
		{
			$fields = $f;
		}


		//=========================
		$return = new StdClass();
		$return->users = array();
		$return->page_title = $this->params->get('page_title', 'Subscribers');
		$return->description = $this->params->get('custom_description', '');
		$return->notice = !$this->params->get('disable_notice', 0);
		//=========================


		if (count($fields) < 1)
		{
			JError::raiseNotice(100, JText::_("There are no subscribtions to genrate custom list"));
			return $return;
		}
		JRequest::setVar('customlist_tmpl', $this->params->get('template', 'default'));
		//$sql = "SELECT *, email as custom_data FROM #__users";
		$sql = "SELECT u.*, memberplans.name AS custom_data   FROM #__users AS u
			\n INNER JOIN #__jcs_user_subscr AS mebersubscribtions on u.id = mebersubscribtions.user_id
			\n INNER JOIN #__jcs_plans AS memberplans ON mebersubscribtions.subscription_id = memberplans.id
			\n WHERE memberplans.id IN (".implode(" , ", $fields).") GROUP BY (u.id) LIMIT {$limitstart}, {$limit}
		";

		$db->setQuery($sql);

		$users =  $db->loadObjectList();
		for($i = 0; $i < count($users); $i++)
		{
			$users[$i]->custom_data = "<h4 align='center'>{$users[$i]->custom_data}</h3>";
		}

		$sql = "SELECT COUNT(*) FROM #__users AS u
		\n INNER JOIN #__jcs_user_subscr AS mebersubscribtions on u.id = mebersubscribtions.user_id
		\n INNER JOIN #__jcs_plans AS memberplans ON mebersubscribtions.subscription_id = memberplans.id
		\n WHERE memberplans.id IN (".implode(" , ", $fields).")
		";

		$db->setQuery($sql);
		$return->total = $db->loadResult();
		$return->users = &$users;


		return $return;
	}

	function _cleanArray($array)
	{
		$ret = array();
		foreach ($array as $val)
		{
			if ($val == '' || empty($val))
			{
				continue;
			}
			else
			{
				$ret[] = $val;
			}

		}
		return $ret;
	}
}
?>