<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityResource extends JPlugin
{
	var $subBlock = array();
	var $section_id = null;
	function plgCommunityResource(&$subject, $config)
	{
		parent::__construct($subject, $config);

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php'))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php';
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php'))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';
		}

		$this->loadLanguage();

		$this->subBlock['created'] = $this->_convertParams($this->params->get('created'));
		$this->subBlock['favorites'] = $this->_convertParams($this->params->get('favourite'));
		$this->subBlock['rated'] = $this->_convertParams($this->params->get('rated'));
		$this->subBlock['commented'] = $this->_convertParams($this->params->get('commented'));
		$this->subBlock['last-visited'] = $this->_convertParams($this->params->get('visited'));
		$this->subBlock['tags'] = $this->_convertParams($this->params->get('tags'));
		$this->section_id = $this->params->get('section');

	}
	function onRenderFilters()
	{
		$selected = JRequest::getVar('juserfilter');


	}
	function onSqlWhere()
	{

	}
	function onSqlJoin()
	{

	}
	function onRenderAvatar(&$user)
	{

	}
	function onProfileCoreData($user)
	{
	}


	function onProfileExtra($user, $params = null, $name)
	{
		if ($name != 'resource'){return;}

		jimport('joomla.application.component.model');

		$me = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$tab = new stdClass();
		$ret = array();
		$SECTION = $this->params->get('section');
		$clients = $this->params->get('show_clients');
		$template = $this->params->get('template_over');

		$sorted = array();
		$pparams = $this->params;
		foreach ($this->subBlock as $key => $block)
		{
			if($block->get('access') == 'hide') continue;
			if($block->get('access') == 'owner' && ($me->get('id') != $user->get('id'))) continue;
			if($key == 'tags')
			{
				//$sorted[$block->get('order')] = $this->getUserTags($user, $block);
				continue;
			}

			$sorted[$block->get('order')] = $this->_useritems($user, $key, $block, $SECTION, $clients, $template);
		}
		$this->params =& $pparams;
		//echo $this->params->get('layout_style'); exit;


		ksort($sorted);

		if (count($sorted))
		{
			return $this->prepareForOutput($sorted);
		}
	}

	function prepareForOutput($blocks = array())
	{
		if (count($blocks) < 1)
		{
			return;
		}
		$block = new JSCommunityTab();


		$block->text.='';
		switch($this->params->get('layout_style'))
		{
			case 'tabs':
			case 'sliders':
				jimport('joomla.html.pane');
				$tabs = &JPane::getInstance($this->params->get('layout_style'));
				$block->text.= $tabs->startPane( 'pane-'.rand(1,1000) );

				foreach ($blocks as $key => $blck)
				{
					if ($blck == null){continue;}
					if (!@$blck->html){continue;}
					$block->text.= $tabs->startPanel($blck->title, $this->_name.'-block'.$key);
					$block->text.= $blck->html;
					$block->text.= $tabs->endPanel();
				}
				$block->text.= $tabs->endPane();
				break;
			case 'classic':
			default:
				foreach ($blocks as $key => $blck)
				{
					if ($blck == null){continue;}
					if (!@$blck->html){continue;}
					$block->text.= "<div class='contentheading'>{$blck->title}</div>";
					$block->text.= $blck->html;

				}
				break;
		}
		$block->title = JText::_("User Resources");
		$block->description = "";
		$block->name = "com_resource";

		return $block;
	}


	function getComments($items, $user = null, $template = null)
	{
		if(!$items) return;
		$Itemid = $this->params->get('item_itemid', JRequest::getInt('Itemid'));
		$sectionId = $this->params->get('section');
		ob_start();

		$template = new JS_People_Touch_Resource_Section_Template('resource_comments', $template);
		include $template->getTemplatePath();

		$contents = ob_get_contents();
		ob_end_clean();

		return $contents;
	}


	function getTagCloud($tags = array(), $template = null)
	{
		if (count($tags)<1)
		{
			return '';
		}
		$section = (int)$this->params->get('section');

		require_once JPATH_ROOT.DS.'plugins'.DS.'community'.DS.'elements'.DS.'sectiontemplate.php';
		ob_start();

		$template = new JS_People_Touch_Resource_Section_Template('resource_user_tags', $template);
		include $template->getTemplatePath();

		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;

	}

	function onProfileMenu($profile)
	{
		$helper = & TouchResourceHelper::getInstance();
		$me = JFactory::getUser();
		
		$obj = $helper->getPluginObject($this->_name, $this->_type);
		
		$plugin_params = new JParameter($obj->plugin_params);
		if (!$plugin_params->get('allow_accesschange')){
			$access = $plugin_params->get('default_access ', 0);
		}else{
			$access = $obj->access;
		}

		if ($access == 1)
		{
			if ($me->get('id')<1)
			{
				return null;;
			}

		} else if ($access == 2)
		{
			$model = &JModel::getInstance('Profile', 'CommunityModel');
			if (($me->get('id') != $profile->id) && (count($model->getFriends($me->get('id')))<1 || $me->get('id') < 1))
			{
				return null;;
			}

		} else if ($access == 3 && ($me->get('id') != $profile->id))
		{
			return null;;
		}
		
		$menu = array();
		
		$ret = new stdClass();
		$ret->menuItems = array();
		
		if ($this->params->get('show_menu_title'))
		{
			$ret->title = JText::_($this->params->get('menu_title', "Content Menu"));
		}
		$menuItem = new stdClass();
		$id = $profile->id;
		

		//----------------------------------------------------------------------
		//index.php?option=com_resource&view=list&layout=useritems&view_what=created&section_id=2
		switch ($this->subBlock['created']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
			default:
				$link = MEUrl::link_list($this->section_id, array('user_id' => $id, 'view_what' => 'created'));
				$menuItem->link =  MERoute::_($link);
				$menuItem->icon = "plugins/community/icons/created.png";
				$menuItem->alt  = JText::_("Created");
				$ret->menuItems[] = clone($menuItem);
				$id = $profile->id;
				break;

		}

		//--------------------------------------------------------------------------
		switch ($this->subBlock['favorites']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
			default:
				$link = MEUrl::link_list($this->section_id, array('user_id' => $id, 'view_what' => 'favorites'));
				$menuItem->link =  MERoute::_($link);
				$menuItem->icon = "plugins/community/icons/favorites.png";
				$menuItem->alt  = JText::_("Favourite");
				$ret->menuItems[] = clone($menuItem);
				break;

		}
		//--------------------------------------------------------------------------
		switch ($this->subBlock['rated']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
			default:
				$link = MEUrl::link_list($this->section_id, array('user_id' => $id, 'view_what' => 'rated'));
				$menuItem->link =  MERoute::_($link);
				$menuItem->icon = "plugins/community/icons/ratings.png";
				$menuItem->alt  = JText::_("Rated");
				$ret->menuItems[] = clone($menuItem);
				break;

		}
		//--------------------------------------------------------------------------
		switch ($this->subBlock['commented']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
				$link = MEUrl::link_list($this->section_id, array('user_id' => $id, 'view_what' => 'commented'));
				$menuItem->link =  MERoute::_($link);
				$menuItem->icon = "plugins/community/icons/comments.png";
				$menuItem->alt  = JText::_("Commented");
				$ret->menuItems[] = clone($menuItem);
				break;

		}
		//--------------------------------------------------------------------------
		switch ($this->subBlock['last-visited']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
			default:
				$link = MEUrl::link_list($this->section_id, array('user_id' => $id, 'view_what' => 'last-visited'));
				$menuItem->link =  MERoute::_($link);
				$menuItem->icon = "plugins/community/icons/visited.png";
				$menuItem->alt  = JText::_("Last Visited");
				$ret->menuItems[] = clone($menuItem);
				break;

		}
		//--------------------------------------------------------------------------
		switch ($this->subBlock['tags']->get('menu_access'))
		{
			case 'hide':
				break;
			case 'owner':
				if ($me->id != $id) break;
			case 'all':
			default:
				$html = $this->params->get('html_tags', 'h1,h2,h3,h4,h5,h6,b,strong,big,small,em');
				if(strstr($html, "\n")) $html = str_replace("\n", ",", $html);
				$menuItem->link =  JRoute::_("index.php?option=com_resource&view=tags&sections[]=".$this->section_id."&user_id={$id}&html=".urlencode($html));
				$menuItem->link .= '&Itemid='.MEUrl::itemid(null, $this->section_id);
				$menuItem->icon = "plugins/community/icons/tags.png";
				$menuItem->alt  = JText::_("Tags");
				$ret->menuItems[] = clone($menuItem);
				break;

		}

		if (count($ret->menuItems))
		{
			return $ret;
		}
	}

	function getUserTags($user, $template, $section)
	{
		$db = &JFactory::getDBO();
		$tab = new JSCommunityTab();

		$sql = "SELECT t.tag, t.id FROM #__js_res_tags AS t "
		.' LEFT JOIN #__js_res_tags_history AS th ON t.id = th.tag_id '
		.' WHERE th.user_id ='.(int)$user->id.' AND th.section_id = '.$section
		.'';
		$db->setQuery($sql);
		$tags  = $db->loadObjectList();
		if (count($tags)<1)
		{
			return '';
		}
		$tab->text  = $this->getTagCloud($tags, $template);
		$tab->title = JText::_("Tags");
		$tab->name  = 'jsc_user_tags';
		return $tab;
	}

	function checkParameters($user, $params,  $key, $default = NULL)
	{
		if (!$params->get($key, $default))
		{
			return false;

		}
		return $params->get($key, $default);
	}

	function _convertParams($value = array())
	{
		$params = new JParameter('');

		@$params->set('access', @$value[0]);
		@$params->set('limit', @$value[1]);
		@$params->set('order', @$value[2]);
		@$params->set('activity', @$value[3]);
		@$params->set('menu_access', @$value[4]);
		@$params->set('template', @$value[5]);

		return $params;
	}

	function _useritems( $user, $view_what, $block, $section, $clients, $template)
	{
		global $mainframe;
		static $m;

		$options['limit'] = $block->get('limit', 10);
		$options['template'] = $template;
		$options['category'] = $section;
		$options['view_what'] = $view_what;
		$options['user_id'] = $user->id;
		$options['records_mode'] =2;
		$options['client'] = 'module';
		$options['list_clients'] = $clients;

		$o = '';
		if(!$m)
		{
			JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
			$m = JModel::getInstance('list', 'ResModel');
		}
		
		$items = MightyResourcesApi::getRecordList($options, array(), array(), $m, $o);

		if(count($items[0]) <= 0) return false;

		switch($view_what)
		{
			case "rated":
				$title = JText::_("Rated");
				break;
			case "favorites":
				$title = JText::_("Favorites");
				break;
			case "commented":
				$title = JText::_("Commented");
				break;
			case "last-visited":
				$title = JText::_("Last Visited");
				break;
			case "created":
				$title = JText::_("Created");
				break;
		}
		
		$link = MEUrl::link_list($section, array('user_id' => $user->id, 'view_what' => $view_what));
		$link = JHTML::link(MERoute::_($link), JText::sprintf('View all %s', $title), array('class' => 'readon'));

		jimport ('joomla.utilities.date');
		$contents = new StdClass();
		$contents->title = $title;
		$contents->html = $items[1];
		$contents->html .= sprintf('<br /><div align="right">%s</div><br style="clear:both" />', $link);
		return $contents;


		//require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';
		//$helper = & JS_Res_Community_Helper_v1::getInstance();
		//$contents = $helper->getUserItems($user, $view_what, $this->params->get('section'), $limit, $title, $this->params->get('show_clients', 0));
		//$contents->title = $title;
		//return $contents;
	}

	function _cleanArray($array)
	{
		$ret = array();
		foreach ($array as $val)
		{
			if (empty($val))
			{
				continue;
			}
			else
			{
				$ret[] = $val;
			}

		}
		return $ret;
	}

	function onCustomUserList($client, $limitstart = 0, $limit = 0)
	{

		if($client != 'resource'){return;}
		global $mainframe;
		$db = &JFactory::getDBO();
		$view_what = JRequest::getVar('view_what', '');
		$articleId = JRequest::getInt('article', 0);
		if ($view_what == '' || $articleId == 0){return;}
		/**
		 * rated
		 * commented
		 * hit
		 * favourited
		 *
		 */
		$sql = "SELECT title FROM #__js_res_record WHERE id = {$articleId}";
		$db->setQuery($sql);
		$title = $db->loadResult();
		$return = new StdClass();
		$pathway = &$mainframe->getPathway();
		//$return->description = $group->get('description');
		$return->notice = 0;
		//$user->custom_data
		$return->description="";
		$limitStr = "";
		if ($limit > 0)
		{
			$limitStr = " LIMIT ".($limitstart>0?$limitstart.",":"")." {$limit}";

		}
		//JRequest::setVar('customlist_tmpl', 'default');
		$users = array();
		$bread = "";
		switch($view_what)
		{
			case 'rated':
				$bread = JText::_("Rated Users");
				// set title
				$return->page_title = JText::sprintf("Users rated %s", $title);

				$q = "(SELECT ".
				   "v.record_id, v.vote, v.ctime, v.ip, -1 as id, 'Anonymous' as name, 'Anonymous' as username, '' as email, '' as password, ".
				   "'Public Frontend' as usertype, 0 as block, 0 as sendEmail, 29 as gid, '0000-00-00 00:00:00' as registerDate, '0000-00-00 00:00:00' lastvisitDate, '' as activation, '' as params ".
				 	"FROM #__js_res_vote v ".
				"WHERE ".
						"v.record_id = {$articleId} AND v.user_id = 0 GROUP by v.user_id)".
				"UNION".
				"(SELECT ".
						"v.record_id, v.vote, v.ctime, v.ip, u.* ".
					"FROM ".
						" #__users u LEFT JOIN #__js_res_vote v ON v.user_id = u.id ".
					"WHERE ".
						"v.record_id = {$articleId} GROUP by v.user_id) ".$limitStr;

				$db->setQuery( $q );
				$users = $db->loadObjectList();

				$this->_getCustomListOutput($users, 'rated');

				$return->total = count($users);
				break;
			case 'commented':
				$bread = JText::_("Commented Users");
				$return->page_title = JText::sprintf("Users commented %s", $title);
				$sql = "(SELECT ".
				   "-1 as id, 'Anonymous' as name, 'Anonymous' as username, '' as email, '' as password, ".
				   "'Public Frontend' as usertype, 0 as block, 0 as sendEmail, 29 as gid, '0000-00-00 00:00:00' as registerDate, '0000-00-00 00:00:00' lastvisitDate, '' as activation, '' as params, ".
					"rcom.subject, rcom.comment, COUNT(rcom.id) AS `total` ".
				 	"FROM ".
				 		"#__js_res_comments AS rcom "
				 		."WHERE ".
				 		"rcom.record_id = {$articleId} AND rcom.published = 1 AND rcom.user_id = 0 ".
				 	" GROUP BY rcom.user_id )".
				 	" UNION ".
				 	"(SELECT u.*, rcom.subject, rcom.comment, COUNT(rcom.id) AS `total` FROM #__users AS u"
				 	."\n  INNER JOIN #__js_res_comments AS rcom ON u.id = rcom.user_id  "
				 	."\n  WHERE rcom.record_id = {$articleId} AND rcom.published = 1 GROUP BY u.id ORDER BY rcom.ctime DESC) ".$limitStr;
				 	$db->setQuery($sql);

				 	$users = $db->loadObjectList();
				 	$this->_getCustomListOutput($users, 'commented');

				 	$return->total = count($users);
				 	break;
			case 'hit':
				$bread = JText::_("Users viewed");
				$return->page_title = JText::sprintf("Users viewed %s", $title);

				$q = "(SELECT ".
				   "-1 as id, 'Anonymous' as name, 'Anonymous' as username, '' as email, '' as password, ".
				   "'Public Frontend' as usertype, 0 as block, 0 as sendEmail, 29 as gid, '0000-00-00 00:00:00' as registerDate, '0000-00-00 00:00:00' lastvisitDate, '' as activation, '' as params, ".
				   " rh.ctime as hitdate, COUNT(rh.id) AS `total` ".
				"FROM ".
				    "#__js_res_hits AS rh ".
				"WHERE ".
					"rh.record_id = {$articleId} AND user_id = 0 ".
				"GROUP BY ".
				  "(rh.user_id) ".
				"ORDER BY ".
				"rh.ctime DESC) ".

				"UNION ".

				"(SELECT ".
					"u.*, rh.ctime as hitdate, COUNT(rh.id) AS `total` ".
				"FROM ".
				            "#__users AS u ".
				"INNER JOIN  #__js_res_hits AS rh ON u.id = rh.user_id ".
				"WHERE ".
					"rh.record_id = {$articleId} ".
				"GROUP BY ".
				  "(u.id) ".
				"ORDER BY ".
				  "rh.ctime DESC ".
				") ".$limitStr;

				$db->setQuery( $q );

				$users = $db->loadObjectList();

				$this->_getCustomListOutput($users, 'hit');

				$return->total = count($users);
				break;
			case 'favourited':
				$bread = JText::_("Users added to favourites");
				$return->page_title = JText::sprintf("Users added to favorites %s", $title);

				$sql = "(SELECT ".
				   "-1 as id, 'Anonymous' as name, 'Anonymous' as username, '' as email, '' as password, ".
				   "'Public Frontend' as usertype, 0 as block, 0 as sendEmail, 29 as gid, '0000-00-00 00:00:00' as registerDate, '0000-00-00 00:00:00' lastvisitDate, '' as activation, '' as params, ".
					"rf.ctime as favdate ".
				"FROM ".
				    "#__js_res_favorite AS rf ".
				"WHERE ".
					"rf.record_id = {$articleId} AND user_id = 0 ".
				"GROUP BY ".
				  "(rf.user_id) ".
				"ORDER BY ".
				"rh.ctime DESC) ".
				"UNION ".

				"(SELECT u.*, rf.ctime as favdate  FROM #__users AS u"
				."\n  INNER JOIN #__js_res_favorite AS rf ON u.id = rf.user_id  "
				."\n  WHERE rf.record_id = {$articleId} GROUP BY (u.id) ORDER BY rf.ctime DESC) ".$limitStr;
				$db->setQuery($sql);

				$users = $db->loadObjectList();

				$this->_getCustomListOutput($users, 'favourited');

				$return->total = count($users);
				break;
			default:
				return;
				break;

		}
		$pathway->addItem($bread);
		$return->users = $users;

		return $return;

	}

	function _getCustomListOutput(&$users, $type) {
		for($i = 0; $i<count($users); $i++)
		{
			$item = &$users[$i];
			$item->custom_data = '';

			if ($item->id <= 0) {
				$item->custom_data = '<a href="javascript:void(0);">'.JText::_('Anonymous').'</a>';
			}

			switch($type)
			{
				case 'rated':
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='center'><h2 align='center'>{$item->vote}%</h2></td></tr></table>";
					break;
				case 'commented':
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='center'><b>".JText::_('Comments')." : ".$item->total."</b></td></tr></table>";
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='left'><h3>{$item->subject}</h3><br />{$item->comment}</td></tr></table>";
					break;
				case 'hit':
					jimport('joomla.utilities.date');
					$date = new JDate($item->hitdate);
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='center'><b>".$date->toFormat(JText::_('DATE_FORMAT_LC1'))."</b></td></tr></table>";
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='center'><b>".JText::_('Hits')." : ".$item->total."</b></td></tr></table>";
					break;
				case 'favourited':
					jimport('joomla.utilities.date');
					$date = new JDate($item->favdate);
					$item->custom_data .= "<table width='100%'><tr><td valign='middle' align='center'><b>".$date->toFormat(JText::_('DATE_FORMAT_LC1'))."</b></td></tr></table>";
					break;
			}

		}
	}
}
?>
