<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityResource_comments extends JPlugin
{
	function plgCommunityResource_comments(&$subject, $config)
	{
		parent::__construct($subject, $config);
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php'))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';
		}
	}

	function onProfileExtra($user, $params = null, $name)
	{
		if ($name != 'resource_comments')return;

		$helper = & TouchResourceHelper::getInstance();

		$sectionParams = $helper->convertParams($this->params->get('commented'), 9);
		usort($sectionParams, array($helper, '_sortParamsFunc'));
		
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
		$section = & JTable::getInstance('category', 'Res');
		
		$document = &JFactory::getDocument();
		$document->addStyleSheet( JURI::root().'components/com_resource/library/css/style.css' );
		
		$me = &JFactory::getUser();
		$db = &JFactory::getDBO();

		$blocks = array();

		foreach ($sectionParams as $v) {
		    
		    $block = new stdClass();
			$section->reset();
			$section->load($v['id']);

			if($section->published == 0) continue;
			if($v['show_blocks'] == 'hide') continue;
			if($v['show_blocks'] == 'owner' && !MEAccess::isAuthor($user->id)) continue;

			$comments = $this->getComments($user, $v['limit'], $v['id']);
			
			if( empty($comments)) continue;

			ob_start();
			global $comment;
			foreach ($comments AS $comment)
			{
				$sparams = ResHelper::initArticleParams($comment->record_type);
				$this->params->set('comments_avatar', $sparams->get('comments_avatar'));
				$this->params->set('comments_rate', $sparams->get('comments_rate'));
				$this->params->set('comment_time_format', $sparams->get('comment_time_format'));
				$this->params->set('comments_title', 1);// $sparams->get('comments_title'));
				$this->params->set('comments_author', $sparams->get('comments_author'));
				$comment->can_rate = 0;
				$comment->control = 0;
				$comment->name = JSCommunityApi::getUserSlideMenu($user->id, $user->username);
				$link = JURI::root().'index2.php?option=com_community&controller=profile&task=avatar&no_ajax=1&user_id='.$user->id;
				if(is_object($params))
				{
					$link .= '&width='.$sparams->get('comments_avatar_width', 100).'&height='.$sparams->get('comments_avatar_height', 100);
				}
				$comment->avatar = JHTML::image($link, $user->get('username'). JText::_('Avatar'));

				$template = $sparams->get('tmpl_comment');
				
				$link = MEUrl::link_record($comment->record_id, $comment->category_id);
				$comment->subject = JHTML::link(MERoute::_($link)."#comment_".$comment->id, strip_tags($comment->subject));

				include JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'article'.DS.'tmpl'.DS.'default_comments_'.$template.'.php';
			}
				
			$block->html = ob_get_contents();
			ob_end_clean();
			$link = MERoute::_(MEUrl::link_list($v['id'], array('user_id' => $user->id, 'view_what' => 'commented')));
			$link = JHTML::link($link, JText::sprintf('View all commented in %s', $section->name), array('class' => 'readon'));
			$block->html .= sprintf('<br /><div align="right">%s</div><br style="clear:both" />', $link);
			
			$block->title = $v['title'];

			$blocks[] = $block;
		}

		return $helper->prepareForOutput($blocks, $this->params->get('layout_style'), $this->_name);
	}

	function onProfileMenu($user)
	{
		$helper = & TouchResourceHelper::getInstance();
		$menu = $helper->onProfileMenu($user, $this->_name, $this->_type, 'commented', $this->params->get('commented'));
		return $menu;
	}

	function getComments( $user, $limit, $sectionId)
	{
		$db = &JFactory::getDBO();

		if ($limit <= 0)
		$limit = 5;

		if (!empty($limit))
		$limit = 'LIMIT '.(int)$limit;

		$q = " SELECT rcomm.*, rc.title as cat_title, rc.id as category_id, r.type_id as record_type, r.title as record_title FROM #__js_res_comments AS rcomm "
		.' INNER JOIN #__js_res_record AS r ON rcomm.record_id = r.id'
		.' INNER JOIN #__js_res_record_category AS c ON c.record_id = r.id'
		.' INNER JOIN #__js_res_category AS rc ON rc.id = c.catid'
		." WHERE r.client = 'resource' AND rcomm.user_id = ".(int)$user->id
		." AND ( rc.section_id = ".(int)$sectionId." OR rc.id = ".(int)$sectionId." ) AND IF(r.extime != '0000-00-00 00:00:00', r.extime > NOW(), 1) "
		." AND rcomm.published = 1 AND rc.published = 1 AND r.published = 1 AND r.hidden = 0 "
		.' GROUP BY rcomm.id ORDER BY rcomm.ctime DESC '
		.$limit;
		
		$db->setQuery( $q );
		$items = $db->loadObjectList();
		return $items;
	}
}
?>
