<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityResource_personal_categories extends JPlugin
{
	function plgCommunityResource_personal_categories(&$subject, $config)
	{
		parent::__construct($subject, $config);
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php'))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';
		}
	}

	function onProfileExtra($user, $params = null, $name)
	{
		if ($name != 'resource_personal_categories')
		return;

		require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';

		$helper = & TouchResourceHelper::getInstance();
		$me = &JFactory::getUser();

		$sectionParams = $helper->convertParams($this->params->get('personal_categories'));
		usort($sectionParams, array($helper, '_sortParamsFunc'));
		
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
		$section = & JTable::getInstance('category', 'Res');
		$userCategories = $this->getPrivateCategories($user->get('id'), $this->params->get('private_cat_order'));
		if(!$userCategories) return;
		
		$uCatById = array();
		foreach ($userCategories as $cat) {
			if (empty($uCatById[$cat->section_id]))
				$uCatById[$cat->section_id] = array();
			
			$uCatById[$cat->section_id][$cat->id] = $cat;
		}	
		if(!$uCatById) return;

		$blocks = array();

		foreach ($sectionParams as $v) {
			$section->reset();
			$section->load($v['id']);
			$block = new stdClass;
			if($section->published == 0) continue;
			if ($v['show_blocks'] == 'hide') continue;
			if ($v['show_blocks'] == 'owner' && !MEAccess::isAuthor($user->id))	continue;

			if(empty($uCatById[$v['id']])) continue;
			
			$cols = $this->params->get('pcat_cols', 4);
			$width = round(100 / $cols);
			$rows = count($uCatById[$v['id']]) / $cols;
			$rows = ceil($rows); $k = 0;
			$cat_hml = array();
			$limit = 0;
			foreach ($uCatById[$v['id']] as $category) 
			{
				if($limit == $v['limit'])break;
				$link = MEUrl::link_list($v['id'], array('ucid' => $category->id, 'view_what' => 'created', 'user_id' => $user->get('id')));
				$link = JHTML::link($link, $category->name." ({$category->nums})");
				$cat_hml[] = sprintf('<td width="%d%%" align="center">%s%s<span class="small">%s</span></td>', $width, 
				($category->icon ? JHTML::image('images/icons/'.$category->user_id.'/'.$category->icon, $category->name).'<br>' : NULL),
				$link, '<p>'.$category->description.'</p>');
				$limit++;
			}
		
			$html = '<table width="100%" cellpadding="5" cellspacing="0" border="0" summary="Personal categories">';
			for ($c=0; $c<$rows; $c++)
			{
				$html .= '<tr valign="top" align="center">';
				for ($i=0; $i<$cols; $i++)
				{
					$html .= (@$cat_hml[$k] ? $cat_hml[$k] : '<td>&nbsp;</td>');
					$k++;
				}
				$html .= '</tr>';
			}
			$html .= '<tr><td>'.JHTML::link(MEUrl::link_list($v['id'], array('view_what' => 'created', 'user_id' => $user->get('id'))),JText::sprintf('View all created in %s', $section->name), array('class' => 'readon')).'</td></tr>';
			$html .= '</table>';
			$block->html = $html;
			$block->title = $v['title'];
			
			$blocks[] = $block;
		}
		
		return $helper->prepareForOutput($blocks, $this->params->get('layout_style'), $this->_name);
	}
	
	function getPrivateCategories($userId, $order = '')
	{
		$query = 'SELECT c.*, count(r.ucatid) AS nums '.
				' FROM #__js_res_category_user AS c ' .
				' LEFT JOIN #__js_res_record AS r ON r.ucatid = c.id ' .
				' WHERE '.
				' c.published = 1 AND c.user_id = '.(int)$userId. ' AND c.client_id = 0'.
				' GROUP BY c.id '.
				//' HAVING COUNT(r.id) > 0 '.
				'ORDER BY '.
		(!(empty($order)) ? $order : ' c.ordering ')
		;

		$db = & JFactory::getDBO();

		$db->setQuery( $query );

		return $db->loadObjectList();
	}
	/**
	 * Returns menu to display in user profile.
	 * @param $user JUser user
	 * @return stdClass the menu.
	 */
	
	function onProfileMenu($profile)
	{
		$helper = & TouchResourceHelper::getInstance();
		$user = & JFactory::getUser();
		$obj = $helper->getPluginObject($this->_name, $this->_type);
		
		$plugin_params = new JParameter($obj->plugin_params);
		if (!$plugin_params->get('allow_accesschange')){
			$access = $plugin_params->get('default_access ', 0);
		}else{
			$access = $obj->access;
		}

		if ($access == 1)
		{
			if ($user->get('id')<1)
			{
				return null;;
			}

		} else if ($access == 2)
		{
			$model = &JModel::getInstance('Profile', 'CommunityModel');
			if (($user->get('id') != $profile->id) && (count($model->getFriends($user->get('id')))<1 || $user->get('id') < 1))
			{
				return null;;
			}

		} else if ($access == 3 && ($user->get('id') != $profile->id))
		{
			return null;;
		}

		$sectionParams = $helper->convertParams($this->params->get('personal_categories'));
		usort($sectionParams, array($helper, '_sortParamsFunc'));

		$uCategories = $this->getPrivateCategories($profile->get('id'), $this->params->get('private_cat_order'));
		$uCatById = array();
		foreach ($uCategories as $cat) {
			if (empty($uCatById[$cat->section_id]))
			$uCatById[$cat->section_id] = array();

			$uCatById[$cat->section_id][$cat->id] = $cat;
		}


		$menu = new stdClass;
		$menu->title = JText::_($obj->name);
		$menu->menuItems = array();

		foreach ($sectionParams as $k => $v) {
			// skip hidden blocks
			if ($v['show_menu'] != 'Yes')
			continue;

			if (empty($uCatById[$v['id']]))
			continue;

			foreach ($uCatById[$v['id']] as $uCatId => $cat) {
				$menuItem = new stdClass;

				$link = MEUrl::link_list($v['id'], array('ucid' => $uCatId, 'view_what' => 'created', 'user_id' => $user->get('id')));
				
				$menuItem->link = MERoute::_($link);
				$menuItem->alt 	= $cat->name;
				$menuItem->icon = "plugins/community/icons/".$helper->_getIconByViewWhat('created');

				$menu->menuItems [] = $menuItem;
			}

		}

		if (count($menu->menuItems))
		return $menu;

		return null;
	}
}
?>
