<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityResource_user_tags extends JPlugin
{
	function plgCommunityResource_user_tags(&$subject, $config)
	{
		parent::__construct($subject, $config);
		{
			if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php'))
			{
				require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'resource_helper.php';
			}
			
		}
	}

	/**
	 *
	 * @param $user Object from getUser()
	 * @param $params Object
	 * @param $name user name
	 * @return Object Blocks
	 */
	function onProfileExtra($user, $params = null, $name)
	{
		if ($name != 'resource_user_tags')
		return;
			
		$me = &JFactory::getUser();

		$helper = & TouchResourceHelper::getInstance();
		$sectionParams = $helper->convertParams($this->params->get('user_tags'), 5);
		usort($sectionParams, array($helper, '_sortParamsFunc'));
		$document = & JFactory::getDocument();
		$document->addStyleDeclaration('.tag{ clear:both; display:inline; }');
		
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
		$section = & JTable::getInstance('category', 'Res');
		
		$blocks = array();
		$implode = array();
		foreach ($sectionParams as $v) {
			$section->reset();
			$section->load($v['id']);
			$block = new stdClass();
			if($section->published == 0) continue;
			if ($v['show_blocks'] == 'hide') continue;
			if ($v['show_blocks'] == 'owner' && $me->get('id', -12) != $user->get('id', -13)) continue;
			
			//$block = $this->getUserTags($user, $v['limit'], $v['title'], $v['id'], $v['itemid'], $v['template']);
			//if (!$block) continue;
			$tags = $this->getTags($v['id'], $user, array('show_totals' => $this->params->get('show_totals'), 'relevance_mode' => $this->params->get('relevance_mode'), 'limit' => $v['limit'], 'html' => $this->params->get('html_tags', 'H1, H2, H3, H4, H5, H6, strong, b, em, big, small')) );
			$html = explode(',',  $this->params->get('html_tags', 'H1, H2, H3, H4, H5, H6, strong, b, em, big, small'));
			if(!count($tags)) continue;
			
			foreach ($tags AS $tag)
			{
				$link = MEUrl::link_list($tag->catid);
				$link .= '&filter_tag='.$tag->id;
				
				$t = $html[$tag->index];
				$implode[] = sprintf('<a class="tag_%s" href="%s"><%s class="tag">%s</%s></a>', trim($t), $link, trim($t), $tag->tag, trim($t));
			
			}
			htmlspecialchars(print_r($implode, true));
			$block->html = sprintf('<div class="contentpaneopen"><div class="contentpane">%s</div></div>',implode(", ", $implode));
			$block->title = $v['title'];
			
			$blocks[] = $block;
		}
		return $helper->prepareForOutput($blocks, $this->params->get('layout_style'), $this->_name);
	}
	
	function getTags($section, $user, $params)
	{
		$db = JFactory::getDBO();
		$uid = $user->id;

		$where = "";
		if ($uid)
		{
			$where  = " AND h.user_id = {$uid} ";
		}
		if(!$params['relevance_mode'])
		{
			$total = ' SUM(h.hits) AS total ';
		}
		else
		{
			$total = ' COUNT(r.id) AS total ';
		}
		$sql = "SELECT {$total}, t.tag, t.slug, t.id, rc.catid
		FROM #__js_res_tags AS t
		LEFT JOIN #__js_res_tags_history AS h ON h.tag_id = t.id
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = h.record_id
		WHERE h.section_id = $section $where
		GROUP BY t.id
		ORDER BY total DESC";

		if($params['limit'] > 0)
		{
			$sql .= ' LIMIT 0, '.$params['limit'];
		}
		
		$db->setQuery($sql);
		$tags = $db->loadObjectList();
		
		if(!$tags) return array();
		
		if(!$params['html']) $params['html'] = 'H1, H2, H3, H4, H5, H6, strong, b, em, big, small';
		$html = explode(",", $params['html']);
		$html_tags = count($html) - 1;
		
		$tags_max = $tags[0]->total;
		$tags_min = $tags[count($tags) - 1]->total;
		$step = ($tags_max - $tags_min) / $html_tags;
		if($step == 0) $step = 1;

		foreach ($tags AS $i => $tag)
		{
			$tags[$i]->index = abs(floor(($tags_max - $tag->total) / $step));
			if($params['show_totals'])
			{
				$tags[$i]->tag .= " ({$tag->total})";
			}
			@$meta[$tag->tag] += $tag->total;
		}
		shuffle($tags);
		return $tags;
	}

}
?>
